package com.yizhi.drools.application.constant;

/**
 * @ClassName Constants
 * @Description TODO
 * @Author shengchenglong
 * @DATE 2019-11-29 10:08
 * @Version 1.0
 */
public class DroolsConstants {


    public static final Integer DELETED_NO = 0;
    public static final Integer DELETED_YES = 1;

    public static final Integer TEMPLATE_NO = 0;
    public static final Integer TEMPLATE_YES = 1;

    /**
     * 1：内容规则，2：用户规则
     */
    public static final Integer RULE_TYPE_CONTENT = 1;
    public static final Integer RULE_TYPE_USER = 2;

    /**
     * 策略时间类型：1：长期，2：自定义
     */
    public static final Integer STRATEGY_TIME_LONG = 1;
    public static final Integer STRATEGY_TIME_CUSTOM = 2;

    /**
     * 多条规则之间的逻辑关系
     */
    public static final String AND = "and";
    public static final String OR = "or";

    /**
     * 规则item的属性对应值得关系
     */
    public static final String RELATION_EQUALS = "equals";
    public static final String RELATION_NOT_EQUALS = "notEquals";
    public static final String RELATION_CONTAINS = "contains";
    public static final String RELATION_NOT_CONTAINS = "notContains";

    /**
     * 每个业务的标识符
     */
    public static final String BUSINESS_NAME_COURSE = "course";
    public static final String BUSINESS_NAME_TRAININGPROJECT = "trainingProject";
    public static final String BUSINESS_NAME_EXAM = "exam";
    public static final String BUSINESS_NAME_ASSIGNMENT = "assignment";
    public static final String BUSINESS_NAME_RESEARCH = "research";
    public static final String BUSINESS_NAME_LIVE = "live";
    public static final String BUSINESS_NAME_CASE = "case";
    public static final String BUSINESS_NAME_CASEACTIVITY = "caseActivity";
    public static final String BUSINESS_NAME_USER = "account";
    public static final String BUSINESS_NAME_ALBUM = "album";

    /**
     * 每个业务在esearch服务中对应的实体
     */
    public static final String BUSINESS_CLASS_NAME_COURSE = "com.fulan.esearch.pojo.biz.Course";
    public static final String BUSINESS_CLASS_NAME_TRAININGPROJECT = "com.fulan.esearch.pojo.biz.TrainingProject";
    public static final String BUSINESS_CLASS_NAME_EXAM = "com.fulan.esearch.pojo.biz.Exam";
    public static final String BUSINESS_CLASS_NAME_ASSIGNMENT = "com.fulan.esearch.pojo.biz.Assignment";
    public static final String BUSINESS_CLASS_NAME_RESEARCH = "com.fulan.esearch.pojo.biz.Research";
    public static final String BUSINESS_CLASS_NAME_LIVE = "com.fulan.esearch.pojo.biz.Live";
    public static final String BUSINESS_CLASS_NAME_CASE = "com.fulan.esearch.pojo.biz.StudentCase";
    public static final String BUSINESS_CLASS_NAME_CASEACTIVITY = "com.fulan.esearch.pojo.biz.CaseLibrary";
    public static final String BUSINESS_CLASS_NAME_ALBUM = "com.fulan.esearch.pojo.biz.Album";
    public static final String BUSINESS_CLASS_NAME_USER = "com.fulan.esearch.pojo.system.Account";

    /**
     * 根据业务值获取业务在es中的实体类名
     *
     * @param businessName
     * @return
     */
    public static String getBusinessClassName(String businessName) {
        String businessClassName = null;
        switch (businessName) {
            case BUSINESS_NAME_COURSE:
                businessClassName = BUSINESS_CLASS_NAME_COURSE;
                break;
            case BUSINESS_NAME_TRAININGPROJECT:
                businessClassName = BUSINESS_CLASS_NAME_TRAININGPROJECT;
                break;
            case BUSINESS_NAME_EXAM:
                businessClassName = BUSINESS_CLASS_NAME_EXAM;
                break;
            case BUSINESS_NAME_ASSIGNMENT:
                businessClassName = BUSINESS_CLASS_NAME_ASSIGNMENT;
                break;
            case BUSINESS_NAME_RESEARCH:
                businessClassName = BUSINESS_CLASS_NAME_RESEARCH;
                break;
            case BUSINESS_NAME_LIVE:
                businessClassName = BUSINESS_CLASS_NAME_LIVE;
                break;
            case BUSINESS_NAME_CASE:
                businessClassName = BUSINESS_CLASS_NAME_CASE;
                break;
            case BUSINESS_NAME_CASEACTIVITY:
                businessClassName = BUSINESS_CLASS_NAME_CASEACTIVITY;
                break;
            case BUSINESS_NAME_USER:
                businessClassName = BUSINESS_CLASS_NAME_USER;
                break;
            case BUSINESS_NAME_ALBUM:
                businessClassName = BUSINESS_CLASS_NAME_ALBUM;
                break;
            default:
                break;
        }
        return businessClassName;
    }

    /**
     * 根据业务值获取业务的中文名
     *
     * @param businessName
     * @return
     */
    public static String getBusinessCHN(String businessName) {
        String nameCHN = null;
        switch (businessName) {
            case BUSINESS_NAME_COURSE:
                nameCHN = "课程";
                break;
            case BUSINESS_NAME_TRAININGPROJECT:
                nameCHN = "培训项目";
                break;
            case BUSINESS_NAME_EXAM:
                nameCHN = "考试";
                break;
            case BUSINESS_NAME_ASSIGNMENT:
                nameCHN = "作业";
                break;
            case BUSINESS_NAME_RESEARCH:
                nameCHN = "调研";
                break;
            case BUSINESS_NAME_LIVE:
                nameCHN = "直播";
                break;
            case BUSINESS_NAME_CASE:
                nameCHN = "作品";
                break;
            case BUSINESS_NAME_CASEACTIVITY:
                nameCHN = "原创活动";
                break;
            case BUSINESS_NAME_USER:
                nameCHN = "用户";
                break;
            case BUSINESS_NAME_ALBUM:
                nameCHN = "专辑";
                break;
            default:
                break;
        }
        return nameCHN;
    }
}
