package com.yizhi.drools.application.vo.manage;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.NotBlank;

import javax.validation.constraints.NotNull;

/**
 * @ClassName RuleTemplateSave
 * @Description TODO
 * @Author shengchenglong
 * @DATE 2019-11-28 11:28
 * @Version 1.0
 */
@Data
@ApiModel("规则item - vo")
public class RuleItemVo implements Comparable<RuleItemVo> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("业务类型")
    private String business;

    private String businessClassName;

    @NotBlank(message = "property:属性类型不能为空")
    @ApiModelProperty("属性类型")
    private String property;

//    @NotBlank(message = "relation:关系类型不能为空")
    @ApiModelProperty("关系类型")
    private String relation;

    @ApiModelProperty("匹配值")
    private String value;

    @ApiModelProperty("当value为id时，记录下选择的内容的名称")
    private String name;

    @NotNull(message = "sort:排序不能为空")
    @ApiModelProperty("排序")
    private Integer sort;

    @NotBlank(message = "andOr:逻辑关系不能为空")
    @ApiModelProperty("逻辑关系")
    private String andOr;


    @Override
    public int compareTo(RuleItemVo ruleTemplateSave) {
        return this.sort - ruleTemplateSave.getSort();
    }

}
