package com.yizhi.drools.application.vo.manage;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.NotEmpty;
import org.hibernate.validator.constraints.Range;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.util.List;

/**
 * @ClassName RuleTemplateSaveList
 * @Description TODO
 * @Author shengchenglong
 * @DATE 2019-11-28 15:16
 * @Version 1.0
 */
@Data
@ApiModel("规则 - vo")
public class RuleVo {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("规则id，修改必传")
    private Long id;

    @ApiModelProperty("规则名称，引用规则可不传")
    private String name;

    @ApiModelProperty("注意：该id为引用规则的id，如果该值不为空，则后台处理直接引用，不管以下type和list传入任何值（保存为模板可不传）")
    private Long quoteRuleId;

    @ApiModelProperty(value = "and  or(与上一条规则详情的逻辑关系，第一条、仅有一条、都为and)（保存为模板可不传，保存为单条内容规则可不传）")
    private String andOr;

    @NotNull(message = "sort:排序不能为空")
    @ApiModelProperty("排序（保存为模板可不传）")
    private Integer sort;

    @NotNull(message = "type:参数不能为空")
    @Range(min = 1, max = 2, message = "可选值：1内容规则，2用户规则")
    @ApiModelProperty("类型：1内容规则，2用户规则")
    private Integer type;

    @Valid
    @NotEmpty(message = "list:参数不能为空")
    @ApiModelProperty("规则item - 保存vo集合")
    private List<RuleItemVo> list;

    @ApiModelProperty("回显用：是否是模板，如果是模板，则不允许修改")
    private boolean template;

}
