package com.yizhi.drools.application.vo.manage;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.NotEmpty;
import org.hibernate.validator.constraints.Range;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.util.Date;
import java.util.List;

/**
 * @ClassName StratetgyVo
 * @Description TODO
 * @Author shengchenglong
 * @DATE 2019-12-05 10:53
 * @Version 1.0
 */
@Data
@ApiModel("策略保存vo")
public class StrategyVo {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("策略id，修改必传")
    private Long id;

    @NotEmpty(message = "策略名称不能为空")
    @Size(max = 50, message = "策略名称50字以内")
    @ApiModelProperty("策略名称")
    private String strategyName;

    @NotNull(message = "策略时段不能为空")
    @Range(min = 1, max = 2, message = "策略时段选型错误：1：长期，2：自定义")
    @ApiModelProperty(value = "策略时段：1：长期，2：自定义")
    private Integer timeType;

    @ApiModelProperty(value = "自定义时间：开始时间")
    private Date startTime;

    @ApiModelProperty(value = "自定义时间：结束时间")
    private Date endTime;

    @NotEmpty(message = "规则不能为空")
    @ApiModelProperty("规则集合")
    private List<RuleVo> ruleVos;
}
