package com.yizhi.drools.application.domain;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableLogic;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 *
 * </p>
 *
 * @author shengchenglong
 * @since 2019-11-27
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Api(tags = "RecommendRuleItemVo")
@TableName("recommend_rule_item")
public class RecommendRuleItem extends Model<RecommendRuleItem> {

    private static final long serialVersionUID = 1L;


    private Long id;

    @TableField("rule_id")
    private Long ruleId;

    @ApiModelProperty(value = "搜索对象类型名")
    @TableField("class_name")
    private String className;

    @ApiModelProperty(value = "business 类型")
    @TableField("business")
    private String business;

    @ApiModelProperty(value = "搜索属性名称")
    @TableField("property_name")
    private String propertyName;

    @ApiModelProperty(value = "1:contains; 2:notContains; 3:equals; 4:notEquals;")
    private String relation;

    @ApiModelProperty(value = "搜索值（这里注意：contains类似关键词，equals可能是一个指定的id）")
    @TableField("target_val")
    private String targetVal;

    @ApiModelProperty(value = "target_val 为id时，记录name，回显用")
    private String name;

    @ApiModelProperty(value = "1：内容规则，2：用户规则")
    private Integer type;

    @ApiModelProperty(value = "and  or(与上一条规则详情的逻辑关系，第一条、仅有一条、都为and)")
    @TableField("and_or")
    private String andOr;

    @TableLogic
    @ApiModelProperty(value = "1:已删除，0未删除")
    private Integer deleted;

    @ApiModelProperty(value = "排序")
    private Integer sort;

    @ApiModelProperty(value = "组织id")
    @TableField("org_id")
    private Long orgId;

    @ApiModelProperty(value = "站点id")
    @TableField("site_id")
    private Long siteId;

    @ApiModelProperty(value = "企业id")
    @TableField("company_id")
    private Long companyId;

    @ApiModelProperty(value = "创建者id")
    @TableField(value = "create_by_id", fill = FieldFill.INSERT)
    private Long createById;

    @ApiModelProperty(value = "创建者名称")
    @TableField(value = "create_by_name", fill = FieldFill.INSERT)
    private String createByName;

    @ApiModelProperty(value = "创建时间")
    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "更新者id")
    @TableField(value = "update_by_id", fill = FieldFill.UPDATE)
    private Long updateById;

    @ApiModelProperty(value = "修改者名称")
    @TableField(value = "update_by_name", fill = FieldFill.UPDATE)
    private String updateByName;

    @ApiModelProperty(value = "修改时间")
    @TableField(value = "update_time", fill = FieldFill.UPDATE)
    private Date updateTime;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
