package com.yizhi.drools.application.exception;

import com.yizhi.util.application.domain.Response;
import lombok.extern.log4j.Log4j2;
import org.springframework.validation.BindingResult;
import org.springframework.validation.FieldError;
import org.springframework.web.bind.MethodArgumentNotValidException;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

/**
 * @ClassName GlobalExecptionHandler
 * @Description TODO
 * @Author shengchenglong
 * @DATE 2019-11-28 15:57
 * @Version 1.0
 */
@ControllerAdvice
@ResponseBody
@Log4j2
public class GlobalExecptionHandler {

    /**
     * 分隔符
     */
    private static final String SEPARATOR = ",";

    /**
     * 拦截数据校验异常
     *
     * @param request 请求
     * @param e       校验异常
     * @return 通用返回格式
     */
    @ExceptionHandler(MethodArgumentNotValidException.class)
    public Response notValidException(HttpServletRequest request, MethodArgumentNotValidException e) {
        e.printStackTrace();
        BindingResult bindingResult = e.getBindingResult();
        List<String> errorMsgList = new ArrayList();
        for (FieldError fieldError : bindingResult.getFieldErrors()) {
            errorMsgList.add(fieldError.getDefaultMessage());
        }
        return Response.fail(errorMsgList.toString());
    }

}
