package com.yizhi.drools.application.mapper;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.yizhi.drools.application.domain.RecommendRuleItem;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author shengchenglong123
 * @since 2019-11-27
 */
public interface RecommendRuleItemMapper extends BaseMapper<RecommendRuleItem> {

    @Select("<script>" +
            "select * from " +
            "recommend_rule_item " +
            "where rule_id = #{ruleId} and deleted = 0 " +
            "<if test=\"business != null and business != ''\"> " +
            "and business = #{business} " +
            "</if>" +
            "order by sort " +
            "</script>")
    List<RecommendRuleItem> listByRuleId(@Param("ruleId") Long ruleId, @Param("business") String business);

}
