package com.yizhi.drools.application.mapper;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.yizhi.drools.application.domain.RecommendRule;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author shengchenglong123
 * @since 2019-11-27
 */
public interface RecommendRuleMapper extends BaseMapper<RecommendRule> {

    @Select("select * " +
            "from recommend_rule r " +
            "left join recommend_strategy_rule sr on sr.rule_id = r.id " +
            "where r.deleted = 0 and sr.deleted = 0 and sr.strategy_id = #{strategyId} ")
    List<RecommendRule> listByStrategyId(@Param("strategyId") Long strategyId);

    @Select("<script>" +
            "select id " +
            "from recommend_rule " +
            "where template = #{template} and deleted = 0 " +
            "and id in (<foreach item=\"ruleId\" collection=\"ruleIds\" separator=\",\"> " +
            "#{ruleId} " +
            "</foreach>) " +
            "</script>")
    List<Long> listTemplateYesOrNoRuleIds(@Param("ruleIds") List<Long> ruleIds, @Param("template") Integer template);
}
