package com.yizhi.drools.application.mapper;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.yizhi.drools.application.domain.RecommendStrategy;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.session.RowBounds;

import java.util.List;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author shengchenglong123
 * @since 2019-11-27
 */
public interface RecommendStrategyMapper extends BaseMapper<RecommendStrategy> {

    @Select("<script>" +
            "select * " +
            "from recommend_strategy str " +
            "left join recommend_strategy_rule strr on strr.strategy_id = str.id " +
            "where strr.deleted = 0 and str.deleted = 0 " +
            "and strr.rule_id = #{ruleId} " +
            "<if test=\"name != null and name != ''\"> " +
            "and str.name like concat(\"%\", #{name}, \"%\") " +
            "</if> " +
            "</script>")
    List<RecommendStrategy> listByNameAndRuleId(@Param("name") String name, @Param("ruleId") Long ruleId, RowBounds rowBounds);

    @Select("<script>" +
            "select count(1) " +
            "from recommend_strategy str " +
            "left join recommend_strategy_rule strr on strr.strategy_id = str.id " +
            "where strr.deleted = 0 and str.deleted = 0 " +
            "and strr.rule_id = #{ruleId} " +
            "<if test=\"name != null and name != ''\"> " +
            "and str.name like concat(\"%\", #{name}, \"%\") " +
            "</if> " +
            "</script>")
    int countListByNameAndRuleId(@Param("name") String name, @Param("ruleId") Long ruleId);

}
