package com.yizhi.drools.application.mapper;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.yizhi.drools.application.domain.RecommendStrategyRule;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author shengchenglong123
 * @since 2019-11-28
 */
public interface RecommendStrategyRuleMapper extends BaseMapper<RecommendStrategyRule> {

    /**
     * 获取策略下的规则的id
     *
     * @param strategyId
     * @return
     */
    @Select("select rule_id " +
            "from recommend_strategy_rule " +
            "where strategy_id = #{strategyId} and deleted = 0 " +
            "order by sort")
    List<Long> getRuleIds(@Param("strategyId") Long strategyId);

    /**
     * 根据策略id查询 策略-规则 关联
     *
     * @param strategyId
     * @return
     */
    @Select("select * " +
            "from recommend_strategy_rule " +
            "where strategy_id = #{strategyId} and deleted = 0 " +
            "order by sort")
    List<RecommendStrategyRule> listByStrategyId(@Param("strategyId") Long strategyId);

}
