package com.yizhi.drools.application.service;

import com.baomidou.mybatisplus.plugins.Page;
import com.baomidou.mybatisplus.service.IService;
import com.yizhi.drools.application.constant.DroolsConstants;
import com.yizhi.drools.application.domain.RecommendRule;
import com.yizhi.drools.application.vo.manage.RuleVo;

import java.util.List;

/**
 * <p>
 * 服务类
 * </p>
 *
 * @author shengchenglong123
 * @since 2019-11-27
 */
public interface IRecommendRuleService extends IService<RecommendRule> {

    /**
     * 添加规则
     *
     * @param ruleVo
     * @param isTemplate
     * @return 内容规则的id
     * @see DroolsConstants
     */
    Long update(RuleVo ruleVo, Integer isTemplate);

    /**
     * 修改规则
     *
     * @param ruleVo
     * @param isTemplate
     * @return
     */
    Long insert(RuleVo ruleVo, Integer isTemplate);

    /**
     * 规则引用列表
     *
     * @param type
     * @return
     */
    Page<RecommendRule> selectPageByTypeAndName(Page<RecommendRule> page, Integer type, String name);

    List<RuleVo> listRuleVosByStrategyId(Long strategyId, boolean withClassName, String business);

    boolean copy(Long ruleId);

    Page getVisibleRange(Long id, String keyWord, Integer pageNo, Integer pageSize);


}
