package com.yizhi.drools.application.util;

import com.baomidou.mybatisplus.annotations.TableField;
import com.yizhi.core.application.context.ContextHolder;
import com.yizhi.core.application.context.RequestContext;
import lombok.extern.slf4j.Slf4j;

import java.lang.annotation.Annotation;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

/**
 * @ClassName ContextUtil
 * @Description TODO
 * @Author shengchenglong
 * @DATE 2019-12-04 14:06
 * @Version 1.0
 */
@Slf4j
public class ContextUtil {

    /**
     * 拼装 orgId，siteId，companyId
     * @param o
     */
    public static void buildTenantEntity4Insert(Object o) {
        RequestContext context = ContextHolder.get();
        if (context == null) {
            context = new RequestContext();
            context.setOrgId(0L);
            context.setSiteId(0L);
            context.setCompanyId(0L);

        }
        try {
            Class clazz = o.getClass();
            // orgId
            Field field = clazz.getDeclaredField("orgId");
            Annotation annotation = field.getAnnotation(TableField.class);
            Method method;
            if (annotation != null) {
                method = clazz.getMethod("setOrgId", Long.class);
                method.invoke(o, context.getOrgId());
            }

            // siteId
            field = clazz.getDeclaredField("siteId");
            annotation = field.getAnnotation(TableField.class);
            if (annotation != null) {
                method = clazz.getMethod("setSiteId", Long.class);
                method.invoke(o, context.getSiteId());
            }

            // companyId
            field = clazz.getDeclaredField("companyId");
            annotation = field.getAnnotation(TableField.class);
            if (annotation != null) {
                method = clazz.getMethod("setCompanyId", Long.class);
                method.invoke(o, context.getCompanyId());
            }

        } catch (NoSuchFieldException e) {
            log.info(e.getLocalizedMessage());
        } catch (NoSuchMethodException e) {
            log.info(e.getLocalizedMessage());
        } catch (IllegalAccessException e) {
            log.info(e.getLocalizedMessage());
        } catch (InvocationTargetException e) {
            log.info(e.getLocalizedMessage());
        }
    }

    /**
     * 拼装 siteId，companyId
     * @param o
     */
    public static void buildTenantEntity4Select(Object o) {
        RequestContext context = ContextHolder.get();
        if (context == null) {
            context = new RequestContext();
            context.setSiteId(0L);
            context.setCompanyId(0L);

        }
        try {
            Class clazz = o.getClass();

            // siteId
            Field field = clazz.getDeclaredField("siteId");
            Annotation annotation = field.getAnnotation(TableField.class);
            Method method;
            if (annotation != null) {
                method = clazz.getMethod("setSiteId", Long.class);
                method.invoke(o, context.getSiteId());
            }

            // companyId
            field = clazz.getDeclaredField("companyId");
            annotation = field.getAnnotation(TableField.class);
            if (annotation != null) {
                method = clazz.getMethod("setCompanyId", Long.class);
                method.invoke(o, context.getCompanyId());
            }

        } catch (NoSuchFieldException e) {
            e.printStackTrace();
        } catch (NoSuchMethodException e) {
            e.printStackTrace();
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        } catch (InvocationTargetException e) {
            e.printStackTrace();
        }
    }

}
